Index: Fl_Window_Type.cxx
===================================================================
--- Fl_Window_Type.cxx	(revision 9209)
+++ Fl_Window_Type.cxx	(working copy)
@@ -1499,12 +1499,16 @@
   if (!c) c = "Fl_Group";
 
   write_h("\nclass %s : public %s {\n", name(), c);
-  if (strstr(c, "Window")) {
-    write_h("  void _%s();\n", trimclassname(name()));
+  write_h("  void _%s();\n", trimclassname(name()));
+  write_h("  typedef %s SUPERCLASS;\n", c);
+  write_h("  typedef %s THISCLASS;\n", name());
     write_h("public:\n");
+  write_h("  %s();\n", trimclassname(name()));
+  int isWindow = strstr(c, "Window") != NULL;
+  if (isWindow) {
+
     write_h("  %s(int X, int Y, int W, int H, const char *L = 0);\n", trimclassname(name()));
     write_h("  %s(int W, int H, const char *L = 0);\n", trimclassname(name()));
-    write_h("  %s();\n", trimclassname(name()));
 
     // a constructor with all four dimensions plus label
     write_c("%s::%s(int X, int Y, int W, int H, const char *L)\n", name(), trimclassname(name()));
@@ -1515,10 +1519,24 @@
     // a constructor with just the size and label. The window manager will position the window
     write_c("%s::%s(int W, int H, const char *L)\n", name(), trimclassname(name()));
     write_c("  : %s(0, 0, W, H, L) {\n", c);
-    write_c("  clear_flag(16);\n");
+    write_c("  clear_flag(GROUP_RELATIVE);\n");
     write_c("  _%s();\n", trimclassname(name()));
     write_c("}\n\n");
     
+//    write_c("  %s *w = this;\n", name());
+  } else {
+    write_h("  %s(int X, int Y, int W, int H, const char *L = 0);\n", trimclassname(name()));
+
+    write_c("%s::%s(int X, int Y, int W, int H, const char *L)\n", name(), trimclassname(name()));
+    if (wc_relative)
+      write_c("  : %s(0, 0, W, H, L) {\n", c);
+    else
+      write_c("  : %s(X, Y, W, H, L) {\n", c);
+    write_c("  _%s();\n", trimclassname(name()));
+    if (wc_relative) write_c("  position(X, Y);\n");
+    write_c("}\n\n");
+  }
+
     // a constructor that takes size and label from the Fluid database
     write_c("%s::%s()\n", name(), trimclassname(name()));
     write_c("  : %s(0, 0, %d, %d, ", c, o->w(), o->h());
@@ -1526,23 +1544,11 @@
     if (cstr) write_cstring(cstr);
     else write_c("0");
     write_c(") {\n");
-    write_c("  clear_flag(16);\n");
+    if (isWindow) write_c("  clear_flag(GROUP_RELATIVE);\n");
     write_c("  _%s();\n", trimclassname(name()));
     write_c("}\n\n");
     
     write_c("void %s::_%s() {\n", name(), trimclassname(name()));
-//    write_c("  %s *w = this;\n", name());
-  } else {
-    write_h("public:\n");
-    write_h("  %s(int X, int Y, int W, int H, const char *L = 0);\n", trimclassname(name()));
-
-    write_c("%s::%s(int X, int Y, int W, int H, const char *L)\n", name(), trimclassname(name()));
-    if (wc_relative)
-      write_c("  : %s(0, 0, W, H, L) {\n", c);
-    else
-      write_c("  : %s(X, Y, W, H, L) {\n", c);
-  }
-
 //  write_c("  %s *o = this;\n", name());
 
   write_widget_code();
@@ -1550,7 +1556,6 @@
 
 void Fl_Widget_Class_Type::write_code2() {
   write_extra_code();
-  if (wc_relative) write_c("%sposition(X, Y);\n", indent());
   if (modal) write_c("%sset_modal();\n", indent());
   else if (non_modal) write_c("%sset_non_modal();\n", indent());
   if (!((Fl_Window*)o)->border()) write_c("%sclear_border();\n", indent());
